> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/api-reference/network-services/cloud-dns/secondary-zones/retrieve-secondary-zones.md).

# Retrieve secondary zones

Returns a list of the secondary DNS zones for the customer. Default limit is the first 100 items. Use pagination query parameters for listing more items (up to 1000).

Supports offset/limit pagination and forward-only cursor pagination via the `pagination.token` parameter. `offset` and `pagination.token` are mutually exclusive (passing both is a `400`). `limit` controls the page size for either. When there are more results to return, the token is returned in the `pagination.token` field of the response body (and in the `_links.next` URL) and is absent on the last page. When a token is used, `_links.prev` is not provided.

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - DNS API","version":"1.18.2"},"tags":[{"name":"SecondaryZones","description":"Endpoints related to secondary zones"}],"servers":[{"url":"https://dns.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"apiKey","description":"Please provide header value as 'Bearer <token>' and don't forget to add 'Bearer' HTTP Authorization Scheme before the token.","name":"Authorization","in":"header"}},"schemas":{"ProvisioningState":{"type":"string","description":"The list of possible provisioning states in which DNS resource could be at the specific time.\n* AVAILABLE - resource exists and is healthy.\n* PROVISIONING - resource is being created or updated.\n* DESTROYING - delete command was issued, the resource is being deleted.\n* FAILED - creation of the resource failed.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"]},"PaginationToken":{"type":"string","pattern":"^[A-Za-z0-9_-]+$","description":"Opaque cursor token identifying a page of results. Returned in the\n`pagination.token` field (and the `_links.next` URL) of a response\nwhen more results remain, and accepted back via the\n`pagination.token` query parameter to fetch that page. The token uses\na URL-safe encoding limited to the characters `A-Z`, `a-z`, `0-9`,\n`-` and `_`, so it can be round-tripped in a query string without\nescaping.\n"},"SecondaryZoneReadList":{"allOf":[{"$ref":"#/components/schemas/CommonZoneReadList"},{"type":"object","description":"List of secondary zones","required":["items"],"properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/SecondaryZoneRead"}}}}]},"CommonZoneReadList":{"type":"object","required":["id","type","href","limit","_links"],"properties":{"id":{"type":"string","format":"uuid","description":"ID (UUID) created to identify this action."},"type":{"type":"string","enum":["collection"]},"href":{"type":"string","format":"uri","readOnly":true},"offset":{"$ref":"#/components/schemas/Offset"},"limit":{"$ref":"#/components/schemas/Limit"},"_links":{"$ref":"#/components/schemas/Links"}}},"Offset":{"type":"number","description":"Pagination offset.","readOnly":true},"Limit":{"type":"number","description":"Pagination limit.","readOnly":true},"Links":{"description":"URLs to navigate the different pages of results.\n","type":"object","properties":{"prev":{"description":"URL of the previous page; only present if offset is greater than\n0. Contains `offset` and `limit`; not returned when paging via\n`pagination.token`, which is forward-only.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL of the current page. Contains `limit` plus either `offset` or\n`pagination.token`, depending on which pagination strategy the\nendpoint supports and the request used.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL of the next page; only present if there are more elements to\nreturn. Contains `limit` plus either `offset` or\n`pagination.token`, depending on which pagination strategy the\nendpoint supports and the request used.\n","type":"string","format":"uri","readOnly":true}}},"SecondaryZoneRead":{"allOf":[{"$ref":"#/components/schemas/CommonZoneRead"},{"type":"object","required":["properties"],"properties":{"properties":{"$ref":"#/components/schemas/SecondaryZone"}}}]},"CommonZoneRead":{"type":"object","required":["id","type","href","metadata"],"properties":{"id":{"type":"string","format":"uuid","description":"The zone ID (UUID)."},"type":{"type":"string","enum":["zone","secondaryzone"]},"href":{"type":"string","format":"uri","readOnly":true},"metadata":{"$ref":"#/components/schemas/MetadataWithStateNameservers"}}},"MetadataWithStateNameservers":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["state","nameservers"],"properties":{"state":{"$ref":"#/components/schemas/ProvisioningState"},"nameservers":{"type":"array","description":"The list of nameservers associated to the zone. \nNameservers are different for primary and secondary zones.\nFor primary zones it would be:\n- ns-ic.ui-dns.com\n- ns-ic.ui-dns.de\n- ns-ic.ui-dns.org\n- ns-ic.ui-dns.biz\n\nAnd for secondary zones:\n- nscs.ui-dns.com\n- nscs.ui-dns.de\n- nscs.ui-dns.org\n- nscs.ui-dns.biz\n","items":{"type":"string"}}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","readOnly":true,"format":"date-time","description":"The creation date formatted as yyyy-MM-dd'T'HH:mm:ss.SSS'Z'."},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"The unique ID of the user who created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","readOnly":true,"format":"date-time","description":"The date of the last change formatted as yyyy-MM-dd'T'HH:mm:ss.SSS'Z'."},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"The unique ID of the user who last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"SecondaryZone":{"allOf":[{"$ref":"#/components/schemas/CommonZone"},{"type":"object","description":"Indicates the fields for a secondary zone to be created","required":["primaryIps"],"properties":{"primaryIps":{"type":"array","items":{"type":"string","anyOf":[{"format":"ipv4"},{"format":"ipv6"}]},"minItems":1,"uniqueItems":true,"description":"Indicates IP addresses of primary nameservers for a secondary zone. Accepts IPv4 and IPv6 addresses"}}}]},"CommonZone":{"type":"object","description":"Indicates the fields for a zone to be created","required":["zoneName"],"properties":{"zoneName":{"type":"string","description":"The zone name"},"description":{"type":"string","description":"The hosted zone is used for..."}}},"Pagination":{"type":"object","readOnly":true,"description":"Cursor pagination details. Only present when there are more results\nto return. Pass the `token` back via the `pagination.token` query\nparameter to fetch the next page.\n","required":["token"],"properties":{"token":{"$ref":"#/components/schemas/PaginationToken"}}},"Error":{"type":"object","additionalProperties":false,"properties":{"httpStatus":{"type":"integer","description":"HTTP status code of the operation as specified by [RFC 7231](https://datatracker.ietf.org/doc/html/rfc7231#section-6).\n"},"messages":{"type":"array","items":{"type":"object","additionalProperties":false,"properties":{"errorCode":{"type":"string","description":"Internal error code.\n"},"message":{"type":"string","description":"Human readable explanation of the issue.\n"}}}}}}},"parameters":{"paginationOffset":{"name":"offset","in":"query","description":"The first element (of the total list of elements) to include in the response. Use together with limit for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":0,"minimum":0}},"paginationLimit":{"name":"limit","in":"query","description":"The maximum number of elements to return. Use together with offset for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":100,"minimum":1,"maximum":1000}},"paginationToken":{"name":"pagination.token","in":"query","description":"An opaque cursor token identifying the page to return, taken from the\n`pagination.token` field (or the `_links.next` URL) of a previous\nresponse. Mutually exclusive with `offset`. `limit` still controls the\npage size. Cursor pagination is forward-only: `_links.prev` is not\navailable when paging via a token.\n","required":false,"schema":{"$ref":"#/components/schemas/PaginationToken"}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/secondaryzones":{"get":{"operationId":"secondaryzonesGet","summary":"Retrieve secondary zones","description":"Returns a list of the secondary DNS zones for the customer. Default\nlimit is the first 100 items. Use pagination query parameters for\nlisting more items (up to 1000).\n\nSupports offset/limit pagination and forward-only cursor pagination via\nthe `pagination.token` parameter. `offset` and `pagination.token` are\nmutually exclusive (passing both is a `400`). `limit` controls the page\nsize for either. When there are more results to return, the token is\nreturned in the `pagination.token` field of the response body (and in\nthe `_links.next` URL) and is absent on the last page. When a token is\nused, `_links.prev` is not provided.\n","parameters":[{"name":"filter.state","in":"query","description":"Filter used to fetch all zones in a particular state.","required":false,"schema":{"$ref":"#/components/schemas/ProvisioningState"}},{"name":"filter.zoneName","in":"query","description":"Filter used to fetch only the zones that contain the specified zone name.","required":false,"schema":{"type":"string"}},{"$ref":"#/components/parameters/paginationOffset"},{"$ref":"#/components/parameters/paginationLimit"},{"$ref":"#/components/parameters/paginationToken"}],"tags":["SecondaryZones"],"responses":{"200":{"description":"Successful operation.","content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/SecondaryZoneReadList"},{"type":"object","properties":{"pagination":{"$ref":"#/components/schemas/Pagination"}}}]}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"500":{"$ref":"#/components/responses/InternalError"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ionos.com/cloud/api-reference/network-services/cloud-dns/secondary-zones/retrieve-secondary-zones.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
